import traceback

from cpl_core.console import Console

from bot_api.abc.dto_abc import DtoABC
from bot_api.model.auth_user_dto import AuthUserDTO


class UpdateAuthUserDTO(DtoABC):
    def __init__(
        self,
        auth_user_dto: AuthUserDTO,
        new_auth_user_dto: AuthUserDTO,
        change_password: bool = False,
    ):
        DtoABC.__init__(self)

        self._auth_user = auth_user_dto
        self._new_auth_user = new_auth_user_dto
        self._change_password = change_password

    @property
    def auth_user(self) -> AuthUserDTO:
        return self._auth_user

    @property
    def new_auth_user(self) -> AuthUserDTO:
        return self._new_auth_user

    @property
    def change_password(self) -> bool:
        return self._change_password

    def from_dict(self, values: dict):
        self._auth_user = AuthUserDTO().from_dict(values["authUser"])
        self._new_auth_user = AuthUserDTO().from_dict(values["newAuthUser"])
        self._change_password = False if "changePassword" not in values else bool(values["changePassword"])

    def to_dict(self) -> dict:
        return {
            "authUser": self._auth_user,
            "newAuthUser": self._new_auth_user,
            "changePassword": self._change_password,
        }
