ALTER TABLE `ApiKeys`
    CHANGE `CreatedAt` `CreatedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6);

ALTER TABLE `ApiKeys`
    CHANGE `LastModifiedAt` `LastModifiedAt` DATETIME(6) NULL DEFAULT CURRENT_TIMESTAMP(6) ON UPDATE CURRENT_TIMESTAMP(6);

CREATE TABLE IF NOT EXISTS `ApiKeysHistory`
(
    `Id`         BIGINT(20)   NOT NULL,
    `Identifier` VARCHAR(255) NOT NULL,
    `Key`        VARCHAR(255) NOT NULL,
    `CreatorId`  BIGINT(20) DEFAULT NULL,
    `Deleted`    BOOL       DEFAULT FALSE,
    `DateFrom`   DATETIME(6)  NOT NULL,
    `DateTo`     DATETIME(6)  NOT NULL
);

DROP TRIGGER IF EXISTS `TR_ApiKeysUpdate`;

CREATE TRIGGER `TR_ApiKeysUpdate`
    AFTER UPDATE
    ON `ApiKeys`
    FOR EACH ROW
BEGIN
    INSERT INTO `ApiKeysHistory` (
        `Id`, `Identifier`, `Key`, `CreatorId`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Identifier, OLD.Key, OLD.CreatorId, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;

DROP TRIGGER IF EXISTS `TR_ApiKeysDelete`;

CREATE TRIGGER `TR_ApiKeysDelete`
    AFTER DELETE
    ON `ApiKeys`
    FOR EACH ROW
BEGIN
    INSERT INTO `ApiKeysHistory` (
        `Id`, `Identifier`, `Key`, `CreatorId`, `Deleted`, `DateFrom`, `DateTo`
    )
    VALUES (
        OLD.Id, OLD.Identifier, OLD.Key, OLD.CreatorId, TRUE, OLD.LastModifiedAt, CURRENT_TIMESTAMP(6)
    );
END;