from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC

from bot_data.model.achievement import Achievement
from bot_data.model.user import User


class UserGotAchievement(TableABC):
    def __init__(
        self,
        user: Optional[User],
        achievement: Optional[Achievement],
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._user = user
        self._achievement = achievement

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def user(self) -> User:
        return self._user

    @property
    def achievement(self) -> Achievement:
        return self._achievement

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
                SELECT * FROM `UserGotAchievements`;
            """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `UserGotAchievements`
                WHERE `Id` = {id};
            """
        )

    @staticmethod
    def get_select_by_user_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `UserGotAchievements`
                WHERE `UserId` = {id};
            """
        )

    @staticmethod
    def get_select_by_achievement_id_string(id: int) -> str:
        return str(
            f"""
                SELECT * FROM `UserGotAchievements`
                WHERE `AchievementId` = {id};
            """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `UserGotAchievements` (
                `UserId`, `AchievementId`
            ) VALUES (
                {self._user.id},
                {self._achievement.id}
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
                UPDATE `UserGotAchievements`
                SET `UserId` = '{self._user.id}',
                `AchievementId` = '{self._achievement.id}'
                WHERE `Id` = {self._id};
            """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
                DELETE FROM `UserGotAchievements`
                WHERE `Id` = {self._id};
            """
        )
