from cpl_core.database.context import DatabaseContextABC

from bot_data.model.user_warnings_history import UserWarningsHistory
from bot_graphql.abc.data_query_with_history_abc import DataQueryWithHistoryABC


class UserWarningQuery(DataQueryWithHistoryABC):
    def __init__(
        self,
        db: DatabaseContextABC,
    ):
        DataQueryWithHistoryABC.__init__(self, "UserWarning", "UserWarningsHistory", UserWarningsHistory, db)

        self.set_field("id", lambda x, *_: x.id)
        self.set_field("user", lambda x, *_: x.user)
        self.set_field("description", lambda x, *_: x.description)
        self.set_field("author", lambda x, *_: x.author)
